package game;

import java.awt.Color;
import java.util.Random;

public class Particle 
{ 
	
	private Random r = new Random();
	
	public Color color;
	public float x;
	public float y;
	
	private float Vx = 0;
	private float Vy = 0;
	private float speed;
	public Smoke smoke = null;
	
	public Particle(int x, int y, Color color,boolean smoke)
	{
		this.x = x - (r.nextFloat()-0.5f)*20;
		this.y = y - (r.nextFloat()-0.5f)*20;
		this.color = color;
		
		speed = r.nextFloat()+20; 
		
		Vx = speed * (r.nextFloat()-0.5f);
		Vy = speed * (r.nextFloat()-0.9f);
		
		if(smoke)
			this.smoke = new Smoke();
		
		
	}
	
	public void update()
	{
		x += Vx;
		y += Vy;
		
		if(Vy < speed)
			Vy += 0.6f;

		if(Vx > 0)
			Vx -= 0.05f;
		else if (Vx < 0)
			Vx += 0.05f;
	}
	

}
